View Issue Details

IDProjectCategoryView StatusLast Update
0037335FPCCompilerpublic2020-08-21 09:01
ReporterChristo Crause Assigned ToFlorian  
PrioritynormalSeverityminorReproducibilityN/A
Status closedResolutionfixed 
Product Version3.3.1 
Fixed in Version3.3.1 
Summary0037335: Xtensa [patch] ESP8266 support for t_freertos.pas
DescriptionAttached patch adds ESP8266 controller support to t_freertos.pas.

The patch follows the ESP32 logic as far as possible. A little bit more detail from the SDK is required to resolve all the linker script symbols, in particular a couple of Kconfig files needs to be passed to ldgen.py to relocate some of the library code in the linker script. If not included some symbols become unreachable during linking. Other details:
- Enclose all Xtensa specific code in ifdefs.
- Resolve IDF_PATH environment variable at start of MakeExecutable and store in a variable for reuse.
- Sdkconfig.h and config.env now gets overwritten every time because the information stored is controller specific.
- Replaced hardcoded binutlis prefix with FindUtil (credit: Alfred in 0037308).
TagsNo tags attached.
Fixed in Revision46527
FPCOldBugId
FPCTarget-
Attached Files

Activities

Christo Crause

2020-07-12 10:02

reporter  

t_freertos.patch (20,422 bytes)   
Index: t_freertos.pas
===================================================================
--- t_freertos.pas	(revision 45742)
+++ t_freertos.pas	(working copy)
@@ -46,8 +46,6 @@
           function postprocessexecutable(const fn : string;isdll:boolean):boolean;
        end;
 
-       var
-         IDF_PATH: string;
 
 {*****************************************************************************
                                   TlinkerEmbedded
@@ -73,21 +71,7 @@
   platform_select='';
 {$endif}
 begin
-  with Info do
-   begin
-{$ifdef xtensa}
-     if target_info.system=system_xtensa_freertos then
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES '+
-         '-u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl -u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
-         '-L $IDF_PATH/components/esp_rom/esp32/ld '+
-         '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
-         '-L . -T esp32_out.ld -T esp32.project.ld '+
-         '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
-     else
-{$else}
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
-{$endif xtensa}
-   end;
+  Info.ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
 end;
 
 
@@ -960,15 +944,16 @@
   t: Text;
   hp: TCmdStrListItem;
   filepath: TCmdStr;
+  {$ifdef XTENSA}
+  IdfPath: TCmdStr;
+  {$endif XTENSA}
 begin
-  IDF_PATH:='';
-{$ifdef xtensa}
-  if (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      IDF_PATH := 'IDF_PATH'
-    else
-      IDF_PATH := 'IDF_PATH8266';
-{$endif xtensa}
+{$ifdef XTENSA}
+  if (current_settings.controllertype = ct_esp32) then
+    IdfPath := trim(GetEnvironmentVariable('IDF_PATH'))
+  else
+    IdfPath := trim(GetEnvironmentVariable('IDF_PATH8266'));
+{$endif XTENSA}
 
   { for future use }
   StaticStr:='';
@@ -979,194 +964,256 @@
   success:=true;
   Result:=false;
 
-  if target_info.system=system_xtensa_freertos then
+  {$ifdef XTENSA}
+  { generate a sdkconfig.h if none is provided,
+    only a few fields are provided to far }
+  if not(Sysutils.FileExists('sdkconfig.h')) then
     begin
-      { generate a sdkconfig.h if none is provided,
-        only a few fields are provided to far }
-      if not(Sysutils.FileExists('sdkconfig.h')) then
+      Assign(t,'sdkconfig.h');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
+
+      if (current_settings.controllertype = ct_esp32) then
         begin
-          Assign(t,'sdkconfig.h');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
           writeln(t,'#pragma once');
           writeln(t,'#define CONFIG_APP_BUILD_USE_FLASH_SECTIONS 1');
           writeln(t,'#define CONFIG_BT_RESERVE_DRAM 0x0');
           writeln(t,'#define CONFIG_ESP32_ULP_COPROC_RESERVE_MEM 0');
           writeln(t,'#define CONFIG_ESP32_TRACEMEM_RESERVE_DRAM 0x0');
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
+        end
+      else
+        begin
+          // TODO: APP_OFFSET & APP_SIZE depends on partition table
+          // Default for partition table: Single factory app, no OTA
+          writeln(t,'#define APP_OFFSET 0x10000');
+          writeln(t,'#define APP_SIZE 0xf0000');
+          // Include build version of sdkconfig.h for custom configuration, if available
+          S:=IdfPath+'/libs/sdkconfig.h';
+          if SysUtils.FileExists(S) then
+            writeln(t,'#include "'+S+'"')
+          else
+            // Assume SOC_FULL_ICACHE option not selected (default)
+            writeln(t,'#define CONFIG_SOC_IRAM_SIZE 0xC000');
         end;
 
-      { generate an sdkconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('sdkconfig')) then
-        begin
-          Assign(t,'sdkconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an sdkconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('sdkconfig')) then
+    begin
+      Assign(t,'sdkconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an Kconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig')) then
-        begin
-          Assign(t,'Kconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an Kconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig')) then
+    begin
+      Assign(t,'Kconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an Kconfig.projbuild if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig.projbuild')) then
-        begin
-          Assign(t,'Kconfig.projbuild');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an Kconfig.projbuild if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig.projbuild')) then
+    begin
+      Assign(t,'Kconfig.projbuild');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an kconfigs.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs.in')) then
-        begin
-          Assign(t,'kconfigs.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an kconfigs.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs.in')) then
+    begin
+      Assign(t,'kconfigs.in');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an kconfigs_projbuild.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
-        begin
-          Assign(t,'kconfigs_projbuild.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an kconfigs_projbuild.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
+    begin
+      Assign(t,'kconfigs_projbuild.in');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate a config.env if none is provided,
-        COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
-        be needed to be filed properly }
-      if not(Sysutils.FileExists('config.env')) then
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
+
+  { generate a config.env if none is provided,
+    COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
+    be needed to be filed properly }
+  //if not(Sysutils.FileExists('config.env')) then
+    begin
+      Assign(t,'config.env');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
+
+      writeln(t,'{');
+      if (current_settings.controllertype = ct_esp32) then
         begin
-          Assign(t,'config.env');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
-
-          writeln(t,'{');
           writeln(t,'    "COMPONENT_KCONFIGS": "Kconfig",');
           writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD": "Kconfig.projbuild",');
           writeln(t,'    "IDF_CMAKE": "y",');
           writeln(t,'    "IDF_TARGET": "esp32",');
-          writeln(t,'    "IDF_PATH": "'+GetEnvironmentVariable('IDF_PATH')+'",');
+          writeln(t,'    "IDF_PATH": "'+IdfPath+'",');
           writeln(t,'    "COMPONENT_KCONFIGS_SOURCE_FILE": "kconfigs.in",');
           writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD_SOURCE_FILE": "kconfigs_projbuild.in"');
-          writeln(t,'}');
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
-
-      { generate ldgen_libraries }
-      Assign(t,'ldgen_libraries');
-      {$push}{$I-}
-      Rewrite(t);
-      if ioresult<>0 then
-        exit;
-
-      hp:=TCmdStrListItem(StaticLibFiles.First);
-      while assigned(hp) do
+        end
+      else
         begin
-          FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
-          writeln(t,filepath);
-          hp:=TCmdStrListItem(hp.Next);
+          writeln(t,'    "IDF_PATH": "'+IdfPath+'",');
+          writeln(t,'    "IDF_TARGET": "esp8266",');
+          writeln(t,'    "IDF_CMAKE": "n"');
         end;
+      writeln(t,'}');
 
       Close(t);
       if ioresult<>0 then
         exit;
       {$pop}
+    end;
 
-      binstr:='xtensa-esp32-elf-gcc';
-      cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld';
+  { generate ldgen_libraries }
+  Assign(t,'ldgen_libraries');
+  {$push}{$I-}
+  Rewrite(t);
+  if ioresult<>0 then
+    exit;
 
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      success:=DoExec(binstr,cmdstr,true,true);
-
-      { generate linker maps for esp32 }
-      binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
-      cmdstr:='--config sdkconfig --fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
-        '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
-        '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
-        '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
-        '$IDF_PATH/components/esp_gdbstub/linker.lf '+
-        '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in --output ./esp32.project.ld --kconfig $IDF_PATH/Kconfig --env-file config.env '+
-        '--libraries-file ldgen_libraries --objdump xtensa-esp32-elf-objdump';
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      if success and not(cs_link_nolink in current_settings.globalswitches) then
-        success:=DoExec(binstr,cmdstr,true,false);
+  hp:=TCmdStrListItem(StaticLibFiles.First);
+  while assigned(hp) do
+    begin
+      FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
+      writeln(t,filepath);
+      hp:=TCmdStrListItem(hp.Next);
     end;
 
-  if IDF_PATH <> '' then
-    Replace(Info.ExeCmd[1],'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
+  Close(t);
+  if ioresult<>0 then
+    exit;
+  {$pop}
+
+  binstr:='gcc';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld'
+  else
+    cmdstr:='-C -P -x c -E -o esp8266_out.ld -I . $IDF_PATH/components/esp8266/ld/esp8266.ld';
+  Replace(cmdstr,'$IDF_PATH',IdfPath);
+  success:=DoExec(FindUtil(utilsprefix+binstr),cmdstr,true,true);
+
+  { generate linker maps }
+  binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
+            '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
+            '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
+            '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
+            '$IDF_PATH/components/esp_gdbstub/linker.lf '+
+            '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in '+
+            '--output ./esp32.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-esp32-elf-objdump'
+  else
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/esp8266/ld/esp8266_fragments.lf '+
+            '$IDF_PATH/components/esp8266/ld/esp8266_bss_fragments.lf $IDF_PATH/components/esp8266/linker.lf '+
+            '$IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/log/linker.lf '+
+            '$IDF_PATH/components/lwip/linker.lf $IDF_PATH/components/spi_flash/linker.lf '+
+            '--env "COMPONENT_KCONFIGS_PROJBUILD=  $IDF_PATH/components/bootloader/Kconfig.projbuild '+
+            '$IDF_PATH/components/esptool_py/Kconfig.projbuild  $IDF_PATH/components/partition_table/Kconfig.projbuild"'+
+            '--env "COMPONENT_KCONFIGS=$IDF_PATH/components/app_update/Kconfig '+
+            '$IDF_PATH/components/esp8266/Kconfig  $IDF_PATH/components/freertos/Kconfig '+
+            '$IDF_PATH/components/log/Kconfig $IDF_PATH/components/lwip/Kconfig" '+
+            '--input $IDF_PATH/components/esp8266/ld/esp8266.project.ld.in '+
+            '--output ./esp8266.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-lx106-elf-objdump';
+
+  Replace(binstr,'$IDF_PATH',IdfPath);
+  Replace(cmdstr,'$IDF_PATH',IdfPath);
+  if success and not(cs_link_nolink in current_settings.globalswitches) then
+    success:=DoExec(binstr,cmdstr,true,false);
+
+  if (current_settings.controllertype = ct_esp32) then
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl '+
+       '-u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
+       '-L $IDF_PATH/components/esp_rom/esp32/ld '+
+       '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
+       '-L . -T esp32_out.ld -T esp32.project.ld '+
+       '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
+  else
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start -u g_esp_sys_info -u _printf_float -u _scanf_float '+
+      '-L $IDF_PATH/components/esp8266/ld -T esp8266.peripherals.ld -T esp8266.rom.ld '+ // SDK scripts
+      '-L . -T esp8266_out.ld -T esp8266.project.ld'; // Project scripts
+
+  Replace(Info.ExeCmd[1],'$IDF_PATH',IdfPath);
+  {$endif XTENSA}
+
   FixedExeFileName:=maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.elf')));
 
   GCSectionsStr:='--gc-sections';
-  //if not(cs_link_extern in current_settings.globalswitches) then
   if not(cs_link_nolink in current_settings.globalswitches) then
    Message1(exec_i_linking,current_module.exefilename);
 
@@ -1179,8 +1226,9 @@
 { Call linker }
   SplitBinCmd(Info.ExeCmd[1],binstr,cmdstr);
   Replace(cmdstr,'$OPT',Info.ExtraOptions);
-  if target_info.system=system_xtensa_freertos then
-    Replace(cmdstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
+  {$ifdef XTENSA}
+  Replace(cmdstr,'$'+IdfPath,IdfPath);
+  {$endif}
   if not(cs_link_on_target in current_settings.globalswitches) then
    begin
     Replace(cmdstr,'$EXE',FixedExeFileName);
@@ -1212,32 +1260,31 @@
   if success and not(cs_link_nolink in current_settings.globalswitches) then
     success:=PostProcessExecutable(FixedExeFileName,false);
 
-{$ifdef xtensa}
-  if success and (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--elf-sha256-offset 0xb0 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
-    else if (current_settings.controllertype = ct_esp8266) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--version=3 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
+{$ifdef XTENSA}
+  if success then
+   begin
+      binstr:=IdfPath+'/components/esptool_py/esptool/esptool.py';
+      if (current_settings.controllertype = ct_esp32) then
+        begin
+          success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--elf-sha256-offset 0xb0 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+      else if (current_settings.controllertype = ct_esp8266) then
+        begin
+          success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--version=3 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+   end
   else
-{$endif xtensa}
+{$endif XTENSA}
     if success then
       success:=DoExec(FindUtil(utilsprefix+'objcopy'),'-O binary '+
         FixedExeFileName+' '+
t_freertos.patch (20,422 bytes)   

Christo Crause

2020-07-12 10:08

reporter   ~0123912

Tested with ESP8266_RTOS_SDK V3.3

Christo Crause

2020-07-12 10:34

reporter   ~0123913

Apologies, the previous patch still checked if sdkconfig.h existed before writing. This patch disables that check so that it gets recreated every time.
t_freertos2.patch (20,475 bytes)   
Index: compiler/systems/t_freertos.pas
===================================================================
--- compiler/systems/t_freertos.pas	(revision 45742)
+++ compiler/systems/t_freertos.pas	(working copy)
@@ -46,8 +46,6 @@
           function postprocessexecutable(const fn : string;isdll:boolean):boolean;
        end;
 
-       var
-         IDF_PATH: string;
 
 {*****************************************************************************
                                   TlinkerEmbedded
@@ -73,21 +71,7 @@
   platform_select='';
 {$endif}
 begin
-  with Info do
-   begin
-{$ifdef xtensa}
-     if target_info.system=system_xtensa_freertos then
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES '+
-         '-u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl -u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
-         '-L $IDF_PATH/components/esp_rom/esp32/ld '+
-         '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
-         '-L . -T esp32_out.ld -T esp32.project.ld '+
-         '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
-     else
-{$else}
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
-{$endif xtensa}
-   end;
+  Info.ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
 end;
 
 
@@ -960,15 +944,16 @@
   t: Text;
   hp: TCmdStrListItem;
   filepath: TCmdStr;
+  {$ifdef XTENSA}
+  IdfPath: TCmdStr;
+  {$endif XTENSA}
 begin
-  IDF_PATH:='';
-{$ifdef xtensa}
-  if (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      IDF_PATH := 'IDF_PATH'
-    else
-      IDF_PATH := 'IDF_PATH8266';
-{$endif xtensa}
+{$ifdef XTENSA}
+  if (current_settings.controllertype = ct_esp32) then
+    IdfPath := trim(GetEnvironmentVariable('IDF_PATH'))
+  else
+    IdfPath := trim(GetEnvironmentVariable('IDF_PATH8266'));
+{$endif XTENSA}
 
   { for future use }
   StaticStr:='';
@@ -979,194 +964,256 @@
   success:=true;
   Result:=false;
 
-  if target_info.system=system_xtensa_freertos then
+  {$ifdef XTENSA}
+  { generate a sdkconfig.h if none is provided,
+    only a few fields are provided to far }
+  //if not(Sysutils.FileExists('sdkconfig.h')) then
     begin
-      { generate a sdkconfig.h if none is provided,
-        only a few fields are provided to far }
-      if not(Sysutils.FileExists('sdkconfig.h')) then
+      Assign(t,'sdkconfig.h');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
+
+      if (current_settings.controllertype = ct_esp32) then
         begin
-          Assign(t,'sdkconfig.h');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
           writeln(t,'#pragma once');
           writeln(t,'#define CONFIG_APP_BUILD_USE_FLASH_SECTIONS 1');
           writeln(t,'#define CONFIG_BT_RESERVE_DRAM 0x0');
           writeln(t,'#define CONFIG_ESP32_ULP_COPROC_RESERVE_MEM 0');
           writeln(t,'#define CONFIG_ESP32_TRACEMEM_RESERVE_DRAM 0x0');
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
+        end
+      else
+        begin
+          // TODO: APP_OFFSET & APP_SIZE depends on partition table
+          // Default for partition table: Single factory app, no OTA
+          writeln(t,'#define APP_OFFSET 0x10000');
+          writeln(t,'#define APP_SIZE 0xf0000');
+          // Include build version of sdkconfig.h for custom configuration, if available
+          S:=IdfPath+'/libs/sdkconfig.h';
+          if SysUtils.FileExists(S) then
+            writeln(t,'#include "'+S+'"')
+          else
+            // Assume SOC_FULL_ICACHE option not selected (default)
+            writeln(t,'#define CONFIG_SOC_IRAM_SIZE 0xC000');
         end;
 
-      { generate an sdkconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('sdkconfig')) then
-        begin
-          Assign(t,'sdkconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an sdkconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('sdkconfig')) then
+    begin
+      Assign(t,'sdkconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an Kconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig')) then
-        begin
-          Assign(t,'Kconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an Kconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig')) then
+    begin
+      Assign(t,'Kconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an Kconfig.projbuild if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig.projbuild')) then
-        begin
-          Assign(t,'Kconfig.projbuild');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an Kconfig.projbuild if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig.projbuild')) then
+    begin
+      Assign(t,'Kconfig.projbuild');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an kconfigs.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs.in')) then
-        begin
-          Assign(t,'kconfigs.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an kconfigs.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs.in')) then
+    begin
+      Assign(t,'kconfigs.in');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate an kconfigs_projbuild.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
-        begin
-          Assign(t,'kconfigs_projbuild.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-          writeln(t);
+  { generate an kconfigs_projbuild.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
+    begin
+      Assign(t,'kconfigs_projbuild.in');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      writeln(t);
 
-      { generate a config.env if none is provided,
-        COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
-        be needed to be filed properly }
-      if not(Sysutils.FileExists('config.env')) then
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
+
+  { generate a config.env if none is provided,
+    COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
+    be needed to be filed properly }
+  //if not(Sysutils.FileExists('config.env')) then
+    begin
+      Assign(t,'config.env');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
+
+      writeln(t,'{');
+      if (current_settings.controllertype = ct_esp32) then
         begin
-          Assign(t,'config.env');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
-
-          writeln(t,'{');
           writeln(t,'    "COMPONENT_KCONFIGS": "Kconfig",');
           writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD": "Kconfig.projbuild",');
           writeln(t,'    "IDF_CMAKE": "y",');
           writeln(t,'    "IDF_TARGET": "esp32",');
-          writeln(t,'    "IDF_PATH": "'+GetEnvironmentVariable('IDF_PATH')+'",');
+          writeln(t,'    "IDF_PATH": "'+IdfPath+'",');
           writeln(t,'    "COMPONENT_KCONFIGS_SOURCE_FILE": "kconfigs.in",');
           writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD_SOURCE_FILE": "kconfigs_projbuild.in"');
-          writeln(t,'}');
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
-
-      { generate ldgen_libraries }
-      Assign(t,'ldgen_libraries');
-      {$push}{$I-}
-      Rewrite(t);
-      if ioresult<>0 then
-        exit;
-
-      hp:=TCmdStrListItem(StaticLibFiles.First);
-      while assigned(hp) do
+        end
+      else
         begin
-          FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
-          writeln(t,filepath);
-          hp:=TCmdStrListItem(hp.Next);
+          writeln(t,'    "IDF_PATH": "'+IdfPath+'",');
+          writeln(t,'    "IDF_TARGET": "esp8266",');
+          writeln(t,'    "IDF_CMAKE": "n"');
         end;
+      writeln(t,'}');
 
       Close(t);
       if ioresult<>0 then
         exit;
       {$pop}
+    end;
 
-      binstr:='xtensa-esp32-elf-gcc';
-      cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld';
+  { generate ldgen_libraries }
+  Assign(t,'ldgen_libraries');
+  {$push}{$I-}
+  Rewrite(t);
+  if ioresult<>0 then
+    exit;
 
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      success:=DoExec(binstr,cmdstr,true,true);
-
-      { generate linker maps for esp32 }
-      binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
-      cmdstr:='--config sdkconfig --fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
-        '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
-        '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
-        '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
-        '$IDF_PATH/components/esp_gdbstub/linker.lf '+
-        '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in --output ./esp32.project.ld --kconfig $IDF_PATH/Kconfig --env-file config.env '+
-        '--libraries-file ldgen_libraries --objdump xtensa-esp32-elf-objdump';
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      if success and not(cs_link_nolink in current_settings.globalswitches) then
-        success:=DoExec(binstr,cmdstr,true,false);
+  hp:=TCmdStrListItem(StaticLibFiles.First);
+  while assigned(hp) do
+    begin
+      FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
+      writeln(t,filepath);
+      hp:=TCmdStrListItem(hp.Next);
     end;
 
-  if IDF_PATH <> '' then
-    Replace(Info.ExeCmd[1],'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
+  Close(t);
+  if ioresult<>0 then
+    exit;
+  {$pop}
+
+  binstr:='gcc';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld'
+  else
+    cmdstr:='-C -P -x c -E -o esp8266_out.ld -I . $IDF_PATH/components/esp8266/ld/esp8266.ld';
+  Replace(cmdstr,'$IDF_PATH',IdfPath);
+  success:=DoExec(FindUtil(utilsprefix+binstr),cmdstr,true,true);
+
+  { generate linker maps }
+  binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
+            '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
+            '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
+            '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
+            '$IDF_PATH/components/esp_gdbstub/linker.lf '+
+            '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in '+
+            '--output ./esp32.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-esp32-elf-objdump'
+  else
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/esp8266/ld/esp8266_fragments.lf '+
+            '$IDF_PATH/components/esp8266/ld/esp8266_bss_fragments.lf $IDF_PATH/components/esp8266/linker.lf '+
+            '$IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/log/linker.lf '+
+            '$IDF_PATH/components/lwip/linker.lf $IDF_PATH/components/spi_flash/linker.lf '+
+            '--env "COMPONENT_KCONFIGS_PROJBUILD=  $IDF_PATH/components/bootloader/Kconfig.projbuild '+
+            '$IDF_PATH/components/esptool_py/Kconfig.projbuild  $IDF_PATH/components/partition_table/Kconfig.projbuild"'+
+            '--env "COMPONENT_KCONFIGS=$IDF_PATH/components/app_update/Kconfig '+
+            '$IDF_PATH/components/esp8266/Kconfig  $IDF_PATH/components/freertos/Kconfig '+
+            '$IDF_PATH/components/log/Kconfig $IDF_PATH/components/lwip/Kconfig" '+
+            '--input $IDF_PATH/components/esp8266/ld/esp8266.project.ld.in '+
+            '--output ./esp8266.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-lx106-elf-objdump';
+
+  Replace(binstr,'$IDF_PATH',IdfPath);
+  Replace(cmdstr,'$IDF_PATH',IdfPath);
+  if success and not(cs_link_nolink in current_settings.globalswitches) then
+    success:=DoExec(binstr,cmdstr,true,false);
+
+  if (current_settings.controllertype = ct_esp32) then
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl '+
+       '-u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
+       '-L $IDF_PATH/components/esp_rom/esp32/ld '+
+       '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
+       '-L . -T esp32_out.ld -T esp32.project.ld '+
+       '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
+  else
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start -u g_esp_sys_info -u _printf_float -u _scanf_float '+
+      '-L $IDF_PATH/components/esp8266/ld -T esp8266.peripherals.ld -T esp8266.rom.ld '+ // SDK scripts
+      '-L . -T esp8266_out.ld -T esp8266.project.ld'; // Project scripts
+
+  Replace(Info.ExeCmd[1],'$IDF_PATH',IdfPath);
+  {$endif XTENSA}
+
   FixedExeFileName:=maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.elf')));
 
   GCSectionsStr:='--gc-sections';
-  //if not(cs_link_extern in current_settings.globalswitches) then
   if not(cs_link_nolink in current_settings.globalswitches) then
    Message1(exec_i_linking,current_module.exefilename);
 
@@ -1179,8 +1226,9 @@
 { Call linker }
   SplitBinCmd(Info.ExeCmd[1],binstr,cmdstr);
   Replace(cmdstr,'$OPT',Info.ExtraOptions);
-  if target_info.system=system_xtensa_freertos then
-    Replace(cmdstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
+  {$ifdef XTENSA}
+  Replace(cmdstr,'$'+IdfPath,IdfPath);
+  {$endif}
   if not(cs_link_on_target in current_settings.globalswitches) then
    begin
     Replace(cmdstr,'$EXE',FixedExeFileName);
@@ -1212,32 +1260,31 @@
   if success and not(cs_link_nolink in current_settings.globalswitches) then
     success:=PostProcessExecutable(FixedExeFileName,false);
 
-{$ifdef xtensa}
-  if success and (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--elf-sha256-offset 0xb0 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
-    else if (current_settings.controllertype = ct_esp8266) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--version=3 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
+{$ifdef XTENSA}
+  if success then
+   begin
+      binstr:=IdfPath+'/components/esptool_py/esptool/esptool.py';
+      if (current_settings.controllertype = ct_esp32) then
+        begin
+          success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--elf-sha256-offset 0xb0 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+      else if (current_settings.controllertype = ct_esp8266) then
+        begin
+          success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--version=3 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+   end
   else
-{$endif xtensa}
+{$endif XTENSA}
     if success then
       success:=DoExec(FindUtil(utilsprefix+'objcopy'),'-O binary '+
         FixedExeFileName+' '+
t_freertos2.patch (20,475 bytes)   

Florian

2020-08-18 21:47

administrator   ~0124973

https://docs.espressif.com/projects/esp8266-rtos-sdk/en/latest/get-started/index.html#get-started-get-esp-idf recommends to use IDF_PATH as well. Where does the IDF_PATH8266 come from?

Christo Crause

2020-08-19 07:37

reporter   ~0124977

I'm trying to switch between esp8266 and esp32 seamlessly. One way of referencing the two SDKs in parallel is to use unique environment variables to point to the respective folders. This way with unique environment variables the compiler has an easy job finding the required files.

I use both controllers and SDKs and want the ability to simply switch the controller target and recompile a program for the new target controller. Any other convention to achieve this will be be OK with me.

Florian

2020-08-19 10:11

administrator   ~0124981

I think introducing a new environment variable is not a good idea then I think that we should provide instead a switch which allows to pass the idf path.

Christo Crause

2020-08-19 16:36

reporter   ~0124993

Can we reuse -Ff for the idf path?

Florian

2020-08-19 21:17

administrator   ~0124997

Fine with me.

Christo Crause

2020-08-20 17:32

reporter   ~0125032

Attached a reworked patch which accepts a -Ff switch to point to the IDF folder. If not set, then the environment variable IDF_PATH is read. The new patch updates the t_freertos.pas file to the new behaviour. The new patch also adds code to read the -Ff switch and store the path in a global variable, together with updating the message describing the -Ff switch.
esp8266-freertos.patch (49,443 bytes)   
Index: compiler/globals.pas
===================================================================
--- compiler/globals.pas	(revision 46462)
+++ compiler/globals.pas	(working copy)
@@ -254,7 +254,10 @@
        { specified with -FW and -Fw }
        wpofeedbackinput,
        wpofeedbackoutput : TPathStr;
-
+{$ifdef XTENSA}
+       { specified with -Ff }
+       idfpath           : TPathStr;
+{$endif XTENSA}
        { external assembler extra option }
        asmextraopt       : string;
 
Index: compiler/msg/errore.msg
===================================================================
--- compiler/msg/errore.msg	(revision 46462)
+++ compiler/msg/errore.msg	(working copy)
@@ -3961,7 +3961,7 @@
 **2FD<x>_Set the directory where to search for compiler utilities
 **2Fe<x>_Redirect error output to <x>
 **2FE<x>_Set exe/unit output path to <x>
-**2Ff<x>_Add <x> to framework path (Darwin only)
+**2Ff<x>_Add <x> to framework path (Darwin only), or set IDF path to <x> (Xtensa-FreeRTOS)
 **2FF_Use fpcres as RC to RES compiler instead of windres or gorc
 **2Fi<x>_Add <x> to include path
 **2Fl<x>_Add <x> to library path
Index: compiler/msgidx.inc
===================================================================
--- compiler/msgidx.inc	(revision 46462)
+++ compiler/msgidx.inc	(working copy)
@@ -1126,7 +1126,7 @@
   option_info=11024;
   option_help_pages=11025;
 
-  MsgTxtSize = 85690;
+  MsgTxtSize = 85732;
 
   MsgIdxMax : array[1..20] of longint=(
     28,106,356,129,99,63,143,36,223,68,
Index: compiler/msgtxt.inc
===================================================================
--- compiler/msgtxt.inc	(revision 46462)
+++ compiler/msgtxt.inc	(working copy)
@@ -1592,164 +1592,165 @@
   '**2FD<x>_Set the directory where to search for compiler utilities'#010+
   '**2Fe<x>_Redirect error output to <x>'#010+
   '**2FE<x>_Set exe/unit output path to <x>'#010+
-  '**2Ff<x>_Add ','<x> to framework path (Darwin only)'#010+
+  '**2Ff<x>_Add ','<x> to framework path (Darwin only), or set IDF path to'+
+  ' <x> (Xtensa-FreeRTOS)'#010+
   '**2FF_Use fpcres as RC to RES compiler instead of windres or gorc'#010+
   '**2Fi<x>_Add <x> to include path'#010+
   '**2Fl<x>_Add <x> to library path'#010+
-  '**2FL<x>_Use <x> as dynamic linker'#010+
-  '**2Fm<x>_Load unicode conversion tabl','e from <x>.txt in the compiler '+
-  'dir'#010+
+  '**2FL<x>_Use <x> as dynamic li','nker'#010+
+  '**2Fm<x>_Load unicode conversion table from <x>.txt in the compiler di'+
+  'r'#010+
   '**2FM<x>_Set the directory where to search for unicode binary files'#010+
   '**2FN<x>_Add <x> to list of default unit scopes (namespaces)'#010+
   '**2Fo<x>_Add <x> to object path'#010+
-  '**2Fr<x>_Load error message file <x>'#010+
-  '**2FR<x','>_Set resource (.res) linker to <x>'#010+
+  '**','2Fr<x>_Load error message file <x>'#010+
+  '**2FR<x>_Set resource (.res) linker to <x>'#010+
   '**2Fu<x>_Add <x> to unit path'#010+
   '**2FU<x>_Set unit output path to <x>, overrides -FE'#010+
   '**2FW<x>_Store generated whole-program optimization feedback in <x>'#010+
-  '**2Fw<x>_Load previously stored whole-program optimiza','tion feedback '+
+  '**2Fw<x>_Loa','d previously stored whole-program optimization feedback '+
   'from <x>'#010+
   '*g1g_Generate debug information (default format for target)'#010+
   '*g2gc_Generate checks for pointers (experimental, only available on so'+
   'me targets, might generate false positive)'#010+
-  '*g2gh_Use heaptrace unit (for memory leak/co','rruption debugging)'#010+
+  '*g','2gh_Use heaptrace unit (for memory leak/corruption debugging)'#010+
   '*g2gl_Use line info unit (show more info with backtraces)'#010+
   '*g2gm_Generate Microsoft CodeView debug information (experimental)'#010+
   '*g2go<x>_Set debug information options'#010+
-  '*g3godwarfsets_ Enable DWARF '#039'set'#039' type debug informatio','n (b'+
+  '*g3godwarfsets','_ Enable DWARF '#039'set'#039' type debug information (b'+
   'reaks gdb < 6.5)'#010+
   '*g3gostabsabsincludes_ Store absolute/full include file paths in Stabs'+
   #010+
   '*g3godwarfmethodclassprefix_ Prefix method names in DWARF with class n'+
   'ame'#010+
-  '*g3godwarfcpp_ Simulate C++ debug information in DWARF'#010+
-  '*g3godwarfomflinnum','_ Generate line number information in OMF LINNUM '+
-  'records in MS LINK format in addition to the DWARF debug information ('+
-  'Open Watcom Debugger/Linker compatibility)'#010+
-  '*g2gp_Preserve case in stabs symbol names'#010+
-  '*g2gs_Generate Stabs debug informati','on'#010+
+  '*g3godwarfcpp_ Simulate C++ debu','g information in DWARF'#010+
+  '*g3godwarfomflinnum_ Generate line number information in OMF LINNUM re'+
+  'cords in MS LINK format in addition to the DWARF debug information (Op'+
+  'en Watcom Debugger/Linker compatibility)'#010+
+  '*g2gp_Preserve case in stabs symbol ','names'#010+
+  '*g2gs_Generate Stabs debug information'#010+
   '*g2gt_Trash local variables (to detect uninitialized uses; multiple '#039+
   't'#039' changes the trashing value)'#010+
   '*g2gv_Generates programs traceable with Valgrind'#010+
-  '*g2gw_Generate DWARFv2 debug information (same as -gw2)'#010+
-  '*g2gw2_Generate DWARFv2 debug in','formation'#010+
+  '*g2gw_Generate DWARFv2 debug information (same',' as -gw2)'#010+
+  '*g2gw2_Generate DWARFv2 debug information'#010+
   '*g2gw3_Generate DWARFv3 debug information'#010+
   '*g2gw4_Generate DWARFv4 debug information (experimental)'#010+
   '**1i_Information'#010+
   '**2iD_Return compiler date'#010+
   '**2iSO_Return compiler OS'#010+
-  '**2iSP_Return compiler host processor'#010+
-  '**2iTO_Return target OS',#010+
+  '**2iSP_Return compi','ler host processor'#010+
+  '**2iTO_Return target OS'#010+
   '**2iTP_Return target processor'#010+
   '**2iV_Return short compiler version'#010+
   '**2iW_Return full compiler version'#010+
   '**2ia_Return list of supported ABI targets'#010+
   '**2ib_Return the used code generation backend type'#010+
-  '**2ic_Return list of supported CPU instruct','ion sets'#010+
+  '*','*2ic_Return list of supported CPU instruction sets'#010+
   '**2if_Return list of supported FPU instruction sets'#010+
   '**2ii_Return list of supported inline assembler modes'#010+
   '**2im_Return list of supported modeswitches'#010+
-  '**2io_Return list of supported optimizations'#010+
-  '**2ir_Return list of recognized comp','iler and RTL features'#010+
+  '**2io_Return list of supported optimiza','tions'#010+
+  '**2ir_Return list of recognized compiler and RTL features'#010+
   '**2it_Return list of supported targets'#010+
   '**2iu_Return list of supported microcontroller types'#010+
   '**2iw_Return list of supported whole program optimizations'#010+
-  '**1I<x>_Add <x> to include path'#010+
+  '**1I<x>_Add <x> to includ','e path'#010+
   '**1k<x>_Pass <x> to the linker'#010+
-  '**1l','_Write logo'#010+
+  '**1l_Write logo'#010+
   '**1M<x>_Set language mode to <x> / enable modeswitch <x> (see option -'+
   'im)'#010+
   '**2Mfpc_Free Pascal dialect (default)'#010+
   '**2Mobjfpc_FPC mode with Object Pascal support'#010+
-  '**2Mdelphi_Delphi 7 compatibility mode'#010+
-  '**2Mtp_TP/BP 7.0 compatibility',' mode'#010+
+  '**2Mdelphi_Delphi 7 compati','bility mode'#010+
+  '**2Mtp_TP/BP 7.0 compatibility mode'#010+
   '**2Mmacpas_Macintosh Pascal dialects compatibility mode'#010+
   '**2Miso_ISO 7185 mode'#010+
   '**2Mextendedpascal_ISO 10206 mode'#010+
   '**2Mdelphiunicode_Delphi 2009 and later compatibility mode'#010+
-  '**2*_Each mode (as listed above) enables its default set of mod','eswit'+
+  '**2*_Each mode (as li','sted above) enables its default set of modeswit'+
   'ches.'#010+
   '**2*_Other modeswitches are disabled and need to be enabled one by ano'+
   'ther.'#010+
   '**1M<x>-_Disable modeswitch <x> (see option -im)'#010+
   '**1n_Do not read the default config files'#010+
-  '**1o<x>_Change the name of the executable produced to <x>'#010+
-  '**1O','<x>_Optimizations:'#010+
+  '**1o<x>_Change the n','ame of the executable produced to <x>'#010+
+  '**1O<x>_Optimizations:'#010+
   '**2O-_Disable optimizations'#010+
   '**2O1_Level 1 optimizations (quick and debugger friendly)'#010+
   '**2O2_Level 2 optimizations (-O1 + quick optimizations)'#010+
-  '**2O3_Level 3 optimizations (-O2 + slow optimizations)'#010+
-  '**2O4_Level 4 optimizati','ons (-O3 + optimizations which might have un'+
-  'expected side effects)'#010+
+  '**2O3_Level 3 optimizations (-O2 + sl','ow optimizations)'#010+
+  '**2O4_Level 4 optimizations (-O3 + optimizations which might have unex'+
+  'pected side effects)'#010+
   '**2Oa<x>=<y>_Set alignment'#010+
   '**2Oo[NO]<x>_Enable or disable optimizations; see fpc -i or fpc -io fo'+
   'r possible values'#010+
-  '**2Op<x>_Set target cpu for optimizing; see fpc -i or fpc ','-ic for po'+
+  '**2Op<x>_Set tar','get cpu for optimizing; see fpc -i or fpc -ic for po'+
   'ssible values'#010+
   '**2OW<x>_Generate whole-program optimization feedback for optimization'+
   ' <x>; see fpc -i or fpc -iw for possible values'#010+
-  '**2Ow<x>_Perform whole-program optimization <x>; see fpc -i or fpc -iw'+
-  ' for possible values'#010+
-  '**2Os_O','ptimize for size rather than speed'#010+
+  '**2Ow<x>_Perform whole-program optimization <x>; see fpc',' -i or fpc -'+
+  'iw for possible values'#010+
+  '**2Os_Optimize for size rather than speed'#010+
   '**1pg_Generate profile code for gprof (defines FPC_PROFILE)'#010+
   'F*1P<x>_Target CPU / compiler related options:'#010+
   'F*2PB_Show default compiler binary'#010+
-  'F*2PP_Show default target cpu'#010+
-  'F*2P<x>_Set target CPU (aarch64,a','rm,avr,i386,i8086,jvm,m68k,mips,mip'+
-  'sel,powerpc,powerpc64,sparc,x86_64)'#010+
+  'F*2PP_Show default ta','rget cpu'#010+
+  'F*2P<x>_Set target CPU (aarch64,arm,avr,i386,i8086,jvm,m68k,mips,mipse'+
+  'l,powerpc,powerpc64,sparc,x86_64)'#010+
   '**1R<x>_Assembler reading style:'#010+
   '**2Rdefault_Use default assembler for target'#010+
   '3*2Ratt_Read AT&T style assembler'#010+
-  '3*2Rintel_Read Intel style assembler'#010+
-  '4*2Ratt_Read AT&T st','yle assembler'#010+
+  '3*2Rintel_Read ','Intel style assembler'#010+
+  '4*2Ratt_Read AT&T style assembler'#010+
   '4*2Rintel_Read Intel style assembler'#010+
   '8*2Ratt_Read AT&T style assembler'#010+
   '8*2Rintel_Read Intel style assembler'#010+
   '6*2RMOT_Read Motorola style assembler'#010+
   '**1S<x>_Syntax options:'#010+
-  '**2S2_Same as -Mobjfpc'#010+
-  '**2Sc_Support operators like C (*','=,+=,/= and -=)'#010+
+  '**2S2_Same as ','-Mobjfpc'#010+
+  '**2Sc_Support operators like C (*=,+=,/= and -=)'#010+
   '**2Sa_Turn on assertions'#010+
   '**2Sd_Same as -Mdelphi'#010+
   '**2Se<x>_Error options. <x> is a combination of the following:'#010+
   '**3*_<n> : Compiler halts after the <n> errors (default is 1)'#010+
-  '**3*_w : Compiler also halts after warnings'#010+
-  '**3*_n ',': Compiler also halts after notes'#010+
+  '**3*_w : ','Compiler also halts after warnings'#010+
+  '**3*_n : Compiler also halts after notes'#010+
   '**3*_h : Compiler also halts after hints'#010+
   '**2Sf_Enable certain features in compiler and RTL; see fpc -i or fpc -'+
   'ir for possible values)'#010+
-  '**2Sg_Enable LABEL and GOTO (default in -Mtp and -Mdelphi)'#010+
-  '**2Sh_Use re','ference counted strings (ansistring by default) instead '+
-  'of shortstrings'#010+
+  '**2Sg_Enable LABEL and GOTO (','default in -Mtp and -Mdelphi)'#010+
+  '**2Sh_Use reference counted strings (ansistring by default) instead of'+
+  ' shortstrings'#010+
   '**2Si_Turn on inlining of procedures/functions declared as "inline"'#010+
-  '**2Sj_Allows typed constants to be writeable (default in all modes)'#010+
+  '**2Sj_Allows typed constants to be writeable (default in a','ll modes)'#010+
   '**2Sk_Load fpcylix unit'#010+
-  '**2SI<x>','_Set interface style to <x>'#010+
+  '**2SI<x>_Set interface style to <x>'#010+
   '**3SIcom_COM compatible interface (default)'#010+
   '**3SIcorba_CORBA compatible interface'#010+
   '**2Sm_Support macros like C (global)'#010+
   '**2So_Same as -Mtp'#010+
-  '**2Sr_Transparent file names in ISO mode'#010+
-  '**2Ss_Constructor name must be in','it (destructor must be done)'#010+
+  '**2Sr_Transparent file names in ','ISO mode'#010+
+  '**2Ss_Constructor name must be init (destructor must be done)'#010+
   '**2Sv_Support vector processing (use CPU vector extensions if availabl'+
   'e)'#010+
   '**2Sx_Enable exception keywords (default in Delphi/ObjFPC modes)'#010+
-  '**2Sy_@<pointer> returns a typed pointer, same as $T+'#010+
-  '**1s_Do not call as','sembler and linker'#010+
+  '**2Sy_@<pointer> returns a type','d pointer, same as $T+'#010+
+  '**1s_Do not call assembler and linker'#010+
   '**2sh_Generate script to link on host'#010+
   '**2st_Generate script to link on target'#010+
   '**2sr_Skip register allocation phase (use with -alr)'#010+
   '**1T<x>_Target operating system:'#010+
-  '3*2Tandroid_Android'#010+
+  '3*2Tandroid_And','roid'#010+
   '3*2Taros_AROS'#010+
   '3*2Tbeos_BeOS'#010+
-  '3*2Tdarwi','n_Darwin/Mac OS X'#010+
+  '3*2Tdarwin_Darwin/Mac OS X'#010+
   '3*2Tembedded_Embedded'#010+
   '3*2Temx_OS/2 via EMX (including EMX/RSX extender)'#010+
   '3*2Tfreebsd_FreeBSD'#010+
   '3*2Tgo32v2_Version 2 of DJ Delorie DOS extender'#010+
   '3*2Thaiku_Haiku'#010+
-  '3*2Tiphonesim_iPhoneSimulator from iOS SDK 3.2+ (older versions: -','Td'+
+  '3*2Tiphonesim_iPhoneSimu','lator from iOS SDK 3.2+ (older versions: -Td'+
   'arwin)'#010+
   '3*2Tlinux_Linux'#010+
   '3*2Tnativent_Native NT API (experimental)'#010+
@@ -1757,9 +1758,9 @@
   '3*2Tnetware_Novell Netware Module (clib)'#010+
   '3*2Tnetwlibc_Novell Netware Module (libc)'#010+
   '3*2Topenbsd_OpenBSD'#010+
-  '3*2Tos2_OS/2 / eComStation'#010+
+  '3*2Tos2_OS','/2 / eComStation'#010+
   '3*2Tsymbian_Symbian OS'#010+
-  '3*','2Tsolaris_Solaris'#010+
+  '3*2Tsolaris_Solaris'#010+
   '3*2Twatcom_Watcom compatible DOS extender'#010+
   '3*2Twdosx_WDOSX DOS extender'#010+
   '3*2Twin32_Windows 32 Bit'#010+
@@ -1767,8 +1768,8 @@
   '4*2Tandroid_Android'#010+
   '4*2Taros_AROS'#010+
   '4*2Tdarwin_Darwin/Mac OS X'#010+
-  '4*2Tdragonfly_DragonFly BSD'#010+
-  '4*2Tembedded_Emb','edded'#010+
+  '4*','2Tdragonfly_DragonFly BSD'#010+
+  '4*2Tembedded_Embedded'#010+
   '4*2Tfreebsd_FreeBSD'#010+
   '4*2Thaiku_Haiku'#010+
   '4*2Tiphonesim_iPhoneSimulator'#010+
@@ -1777,9 +1778,9 @@
   '4*2Topenbsd_OpenBSD'#010+
   '4*2Tsolaris_Solaris'#010+
   '4*2Twin64_Win64 (64 bit Windows systems)'#010+
-  '6*2Tamiga_Commodore Amiga'#010+
+  '6*2Tamiga_C','ommodore Amiga'#010+
   '6*2Tatari_Atari ST/STe/TT'#010+
-  '6','*2Tembedded_Embedded'#010+
+  '6*2Tembedded_Embedded'#010+
   '6*2Tlinux_Linux'#010+
   '6*2Tnetbsd_NetBSD'#010+
   '6*2Tmacosclassic_Classic Mac OS'#010+
@@ -1787,9 +1788,9 @@
   '8*2Tembedded_Embedded'#010+
   '8*2Tmsdos_MS-DOS (and compatible)'#010+
   '8*2Twin16_Windows 16 Bit'#010+
-  'A*2Tandroid_Android'#010+
+  'A*2Tandroid_','Android'#010+
   'A*2Taros_AROS'#010+
-  'A*2Tdarwin_Darwin/iP','honeOS/iOS'#010+
+  'A*2Tdarwin_Darwin/iPhoneOS/iOS'#010+
   'A*2Tembedded_Embedded'#010+
   'A*2Tfreertos_FreeRTOS'#010+
   'A*2Tgba_Game Boy Advance'#010+
@@ -1799,9 +1800,9 @@
   'A*2Tpalmos_PalmOS'#010+
   'A*2Tsymbian_Symbian'#010+
   'A*2Twince_Windows CE'#010+
-  'a*2Tandroid_Android'#010+
+  'a*2Ta','ndroid_Android'#010+
   'a*2Tdarwin_Darwin/iOS'#010+
-  'a*2Tl','inux_Linux'#010+
+  'a*2Tlinux_Linux'#010+
   'a*2Twin64_Windows 64'#010+
   'J*2Tandroid_Android'#010+
   'J*2Tjava_Java'#010+
@@ -1812,8 +1813,8 @@
   'M*2Tlinux_Linux'#010+
   'P*2Taix_AIX'#010+
   'P*2Tamiga_AmigaOS'#010+
-  'P*2Tdarwin_Darwin/Mac OS X'#010+
-  'P*2Tembedded_Embedded',#010+
+  'P*2Tda','rwin_Darwin/Mac OS X'#010+
+  'P*2Tembedded_Embedded'#010+
   'P*2Tlinux_Linux'#010+
   'P*2Tmacosclassic_Classic Mac OS'#010+
   'P*2Tmorphos_MorphOS'#010+
@@ -1824,9 +1825,9 @@
   'p*2Tembedded_Embedded'#010+
   'p*2Tlinux_Linux'#010+
   'R*2Tlinux_Linux'#010+
-  'R*2Tembedded_Embedded'#010+
+  'R*2Tem','bedded_Embedded'#010+
   'r*2Tlinux_Linux'#010+
-  'r*2Tembedd','ed_Embedded'#010+
+  'r*2Tembedded_Embedded'#010+
   'S*2Tlinux_Linux'#010+
   'S*2Tsolaris_Solaris'#010+
   's*2Tlinux_Linux'#010+
@@ -1836,152 +1837,152 @@
   'x*2Tlinux_Linux'#010+
   'Z*2Tembedded_Embedded'#010+
   'Z*2Tzxspectrum_ZX Spectrum'#010+
-  'Z*2Tmsxdos_MSX-DOS'#010+
-  '**1u<x>_Undefines the symb','ol <x>'#010+
+  'Z*2','Tmsxdos_MSX-DOS'#010+
+  '**1u<x>_Undefines the symbol <x>'#010+
   '**1U_Unit options:'#010+
   '**2Un_Do not check where the unit name matches the file name'#010+
   '**2Ur_Generate release unit files (never automatically recompiled)'#010+
   '**2Us_Compile a system unit'#010+
-  '**1v<x>_Be verbose. <x> is a combination of the following ','letters:'#010+
+  '**1v<x>_Be verbo','se. <x> is a combination of the following letters:'#010+
   '**2*_e : Show errors (default)       0 : Show nothing (except errors)'#010+
   '**2*_w : Show warnings               u : Show unit info'#010+
-  '**2*_n : Show notes                  t : Show tried/used files'#010+
-  '**2*_h : Show hints                  c : S','how conditionals'#010+
+  '**2*_n : Show notes                  t : Show tried/used files'#010,
+  '**2*_h : Show hints                  c : Show conditionals'#010+
   '**2*_i : Show general info           d : Show debug info'#010+
   '**2*_l : Show linenumbers            r : Rhide/GCC compatibility mode'#010+
-  '**2*_s : Show time stamps            q : Show message numbers'#010+
-  '**2*_a : Show everything          ','   x : Show info about invoked too'+
-  'ls'#010+
+  '**2*_s : Show time stamps            q : Show message ','numbers'#010+
+  '**2*_a : Show everything             x : Show info about invoked tools'+
+  #010+
   '**2*_b : Write file names messages   p : Write tree.log with parse tre'+
   'e'#010+
   '**2*_    with full path              v : Write fpcdebug.txt with'#010+
-  '**2*_z : Write output to stderr          lots of debugging info'#010+
-  '**','2*_m<x>,<y> : Do not show messages numbered <x> and <y>'#010+
+  '**2*_z : Write output to',' stderr          lots of debugging info'#010+
+  '**2*_m<x>,<y> : Do not show messages numbered <x> and <y>'#010+
   'F*1V<x>_Append '#039'-<x>'#039' to the used compiler binary name (e.g. f'+
   'or version)'#010+
   '**1W<x>_Target-specific options (targets)'#010+
-  '3*2WA_Specify native type application (Windows)'#010+
-  '4*2WA_Specify native',' type application (Windows)'#010+
+  '3*2WA_Specify native type ','application (Windows)'#010+
+  '4*2WA_Specify native type application (Windows)'#010+
   'A*2WA_Specify native type application (Windows)'#010+
   '3*2Wb_Create a bundle instead of a library (Darwin)'#010+
   'P*2Wb_Create a bundle instead of a library (Darwin)'#010+
-  'p*2Wb_Create a bundle instead of a library (Darwin)'#010+
-  'a*2Wb_Cr','eate a bundle instead of a library (Darwin)'#010+
+  'p*2Wb_Create a bun','dle instead of a library (Darwin)'#010+
+  'a*2Wb_Create a bundle instead of a library (Darwin)'#010+
   'A*2Wb_Create a bundle instead of a library (Darwin)'#010+
   '4*2Wb_Create a bundle instead of a library (Darwin)'#010+
-  '3*2WB_Create a relocatable image (Windows, Symbian)'#010+
-  '3*2WB<x>_Set image base to <x> (Windows,',' Symbian)'#010+
+  '3*2WB_Create a relocatable image (Windows, Symbian',')'#010+
+  '3*2WB<x>_Set image base to <x> (Windows, Symbian)'#010+
   '4*2WB_Create a relocatable image (Windows)'#010+
   '4*2WB<x>_Set image base to <x> (Windows)'#010+
   'A*2WB_Create a relocatable image (Windows, Symbian)'#010+
   'A*2WB<x>_Set image base to <x> (Windows, Symbian)'#010+
-  'Z*2WB<x>_Set image base to <x> (ZX Spectrum)',#010+
+  'Z*','2WB<x>_Set image base to <x> (ZX Spectrum)'#010+
   '3*2WC_Specify console type application (EMX, OS/2, Windows)'#010+
   '4*2WC_Specify console type application (Windows)'#010+
   'A*2WC_Specify console type application (Windows)'#010+
-  'P*2WC_Specify console type application (Classic Mac OS)'#010+
-  '3*2WD_Use DEFFILE to expo','rt functions of DLL or EXE (Windows)'#010+
+  'P*2WC_Specify console type application ','(Classic Mac OS)'#010+
+  '3*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
   '4*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
   'A*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
-  '3*2We_Use external resources (Darwin)'#010+
+  '3*2We_Use external resources (Darwin)',#010+
   '4*2We_Use external resources (Darwin)'#010+
-  'a*2','We_Use external resources (Darwin)'#010+
+  'a*2We_Use external resources (Darwin)'#010+
   'A*2We_Use external resources (Darwin)'#010+
   'P*2We_Use external resources (Darwin)'#010+
   'p*2We_Use external resources (Darwin)'#010+
-  '3*2WF_Specify full-screen type application (EMX, OS/2)'#010+
-  '3*2WG_Specify graphic type applicati','on (EMX, OS/2, Windows)'#010+
+  '3*2WF_Specify full-screen type application (EMX, ','OS/2)'#010+
+  '3*2WG_Specify graphic type application (EMX, OS/2, Windows)'#010+
   '4*2WG_Specify graphic type application (Windows)'#010+
   'A*2WG_Specify graphic type application (Windows)'#010+
   'P*2WG_Specify graphic type application (Classic Mac OS)'#010+
-  '3*2Wi_Use internal resources (Darwin)'#010+
-  '4*2Wi_Use internal resou','rces (Darwin)'#010+
+  '3*2Wi_Use internal r','esources (Darwin)'#010+
+  '4*2Wi_Use internal resources (Darwin)'#010+
   'a*2Wi_Use internal resources (Darwin)'#010+
   'A*2Wi_Use internal resources (Darwin)'#010+
   'P*2Wi_Use internal resources (Darwin)'#010+
   'p*2Wi_Use internal resources (Darwin)'#010+
-  '3*2WI_Turn on/off the usage of import sections (Windows)'#010+
-  '4*2WI_Turn on/off',' the usage of import sections (Windows)'#010+
+  '3*2WI_Turn on/off the usage of i','mport sections (Windows)'#010+
+  '4*2WI_Turn on/off the usage of import sections (Windows)'#010+
   'A*2WI_Turn on/off the usage of import sections (Windows)'#010+
   '8*2Wh_Use huge code for units (ignored for models with CODE in a uniqu'+
   'e segment)'#010+
-  '8*2Wm<x>_Set memory model'#010+
+  '8*2Wm<x>_Set memory ','model'#010+
   '8*3WmTiny_Tiny memory model'#010+
-  '8*3WmSma','ll_Small memory model (default)'#010+
+  '8*3WmSmall_Small memory model (default)'#010+
   '8*3WmMedium_Medium memory model'#010+
   '8*3WmCompact_Compact memory model'#010+
   '8*3WmLarge_Large memory model'#010+
   '8*3WmHuge_Huge memory model'#010+
-  '3*2WM<x>_Minimum Mac OS X deployment version: 10.4, 10.5.1, ... (Darwi'+
+  '3*2WM<x>_Minimum Mac OS X deployment versi','on: 10.4, 10.5.1, ... (Dar'+
+  'win)'#010+
+  '4*2WM<x>_Minimum Mac OS X deployment version: 10.4, 10.5.1, ... (Darwi'+
   'n)'#010+
-  '4*2WM<x>_Mi','nimum Mac OS X deployment version: 10.4, 10.5.1, ... (Dar'+
-  'win)'#010+
   'p*2WM<x>_Minimum Mac OS X deployment version: 10.4, 10.5.1, ... (Darwi'+
   'n)'#010+
-  'P*2WM<x>_Minimum Mac OS X deployment version: 10.4, 10.5.1, ... (Darwi'+
-  'n)'#010+
-  '3*2WN_Do not generate relocation',' code, needed for debugging (Windows'+
-  ')'#010+
+  'P*2WM<x>_Minimum Mac OS X deployment version: 10.4, 10.5.1, ...',' (Dar'+
+  'win)'#010+
+  '3*2WN_Do not generate relocation code, needed for debugging (Windows)'#010+
   '4*2WN_Do not generate relocation code, needed for debugging (Windows)'#010+
   'A*2WN_Do not generate relocation code, needed for debugging (Windows)'#010+
-  'A*2Wp<x>_Specify the controller type; see fpc -i or fpc -iu fo','r poss'+
+  'A*2Wp<x>_Specify the',' controller type; see fpc -i or fpc -iu for poss'+
   'ible values'#010+
   'm*2Wp<x>_Specify the controller type; see fpc -i or fpc -iu for possib'+
   'le values'#010+
   'R*2Wp<x>_Specify the controller type; see fpc -i or fpc -iu for possib'+
   'le values'#010+
-  'V*2Wp<x>_Specify the controller type; see fpc -i or fpc -iu fo','r poss'+
+  'V*2Wp<x>_Specify the',' controller type; see fpc -i or fpc -iu for poss'+
   'ible values'#010+
   'x*2Wp<x>_Specify the controller type; see fpc -i or fpc -iu for possib'+
   'le values'#010+
   '3*2WP<x>_Minimum iOS deployment version: 3.0, 5.0.1, ... (iphonesim)'#010+
-  '4*2WP<x>_Minimum iOS deployment version: 8.0, 8.0.2, ... (iphonesim)'#010+
-  'a*2W','P<x>_Minimum iOS deployment version: 7.0, 7.1.2, ... (Darwin)'#010+
+  '4*2WP<x>_Minimum iOS deployment',' version: 8.0, 8.0.2, ... (iphonesim)'+
+  #010+
+  'a*2WP<x>_Minimum iOS deployment version: 7.0, 7.1.2, ... (Darwin)'#010+
   'A*2WP<x>_Minimum iOS deployment version: 3.0, 5.0.1, ... (Darwin)'#010+
   '3*2WR_Generate relocation code (Windows)'#010+
-  '4*2WR_Generate relocation code (Windows)'#010+
-  'A*2WR_Generate relocation code',' (Windows)'#010+
+  '4*2WR_Generate relocation cod','e (Windows)'#010+
+  'A*2WR_Generate relocation code (Windows)'#010+
   '8*2Wt<x>_Set the target executable format'#010+
   '8*3Wtexe_Create a DOS .EXE file (default)'#010+
   '8*3Wtcom_Create a DOS .COM file (requires tiny memory model)'#010+
-  'P*2WT_Specify MPW tool type application (Classic Mac OS)'#010+
-  '**2WX_Enable executable sta','ck (Linux)'#010+
+  'P*2WT_Specify MPW tool type application (C','lassic Mac OS)'#010+
+  '**2WX_Enable executable stack (Linux)'#010+
   '**1X_Executable options:'#010+
   '**2X9_Generate linkerscript for GNU Binutils ld older than version 2.1'+
   '9.1 (Linux)'#010+
   '**2Xc_Pass --shared/-dynamic to the linker (BeOS, Darwin, FreeBSD, Lin'+
   'ux)'#010+
-  '**2Xd_Do not search default library path (someti','mes required for cro'+
+  '**2Xd_','Do not search default library path (sometimes required for cro'+
   'ss-compiling when not using -XR)'#010+
   '**2Xe_Use external linker'#010+
   '**2Xf_Substitute pthread library name for linking (BSD)'#010+
-  '**2Xg_Create debuginfo in a separate file and add a debuglink section '+
-  'to executable'#010+
-  '**2XD_Try to link uni','ts dynamically      (defines FPC_LINK_DYNAMIC)'#010+
+  '**2Xg_Create debuginfo in a separate file and add a debuglink s','ectio'+
+  'n to executable'#010+
+  '**2XD_Try to link units dynamically      (defines FPC_LINK_DYNAMIC)'#010+
   '**2Xi_Use internal linker'#010+
   'L*2XlS<x>_LLVM utilties suffix (e.g. -7 in case clang is called clang-'+
   '7)'#010+
   '**2XLA_Define library substitutions for linking'#010+
-  '**2XLO_Define order of library linking'#010+
-  '**2XLD_','Exclude default order of standard libraries'#010+
+  '**2X','LO_Define order of library linking'#010+
+  '**2XLD_Exclude default order of standard libraries'#010+
   '**2Xm_Generate link map'#010+
   '**2XM<x>_Set the name of the '#039'main'#039' program routine (default i'+
   's '#039'main'#039')'#010+
-  '**2Xn_Use target system native linker instead of GNU ld (Solaris, AIX)'+
-  #010+
-  'F*2Xp<x>_First search for the',' compiler binary in the directory <x>'#010+
+  '**2Xn_Use target system native linker instead of GNU ld (S','olaris, AI'+
+  'X)'#010+
+  'F*2Xp<x>_First search for the compiler binary in the directory <x>'#010+
   '**2XP<x>_Prepend the binutils names with the prefix <x>'#010+
   '**2Xr<x>_Set the linker'#039's rlink-path to <x> (needed for cross comp'+
-  'ile, see the ld manual for more information) (BeOS, Linux)'#010+
-  '**2XR<x>_Prepend <x> ','to all linker search paths (BeOS, Darwin, FreeB'+
-  'SD, Linux, Mac OS, Solaris)'#010+
+  'ile, see the ld manual for more inform','ation) (BeOS, Linux)'#010+
+  '**2XR<x>_Prepend <x> to all linker search paths (BeOS, Darwin, FreeBSD'+
+  ', Linux, Mac OS, Solaris)'#010+
   '**2Xs_Strip all symbols from executable'#010+
   '**2XS_Try to link units statically (default, defines FPC_LINK_STATIC)'#010+
-  '**2Xt_Link with static libraries (-static is passed to ','linker)'#010+
+  '**2Xt_Link wi','th static libraries (-static is passed to linker)'#010+
   '**2Xv_Generate table for Virtual Entry calls'#010+
   '**2XV_Use VLink as external linker       (default on Amiga, MorphOS)'#010+
   '**2XX_Try to smartlink units             (defines FPC_LINK_SMART)'#010+
   '**1*_'#010+
-  '**1?_Show this help'#010+
-  '**1h_Shows this help witho','ut waiting'
+  '**1?','_Show this help'#010+
+  '**1h_Shows this help without waiting'
 );
Index: compiler/options.pas
===================================================================
--- compiler/options.pas	(revision 46462)
+++ compiler/options.pas	(working copy)
@@ -1698,6 +1698,10 @@
                          ParaFrameworkPath.AddPath(More,false)
                        else
                          frameworksearchpath.AddPath(More,true)
+{$ifdef XTENSA}
+                     else if (target_info.system=system_xtensa_freertos) then
+                       idfpath:=FixPath(More,true)
+{$endif XTENSA}
                      else
                        IllegalPara(opt);
                  'F' :
Index: compiler/systems/t_freertos.pas
===================================================================
--- compiler/systems/t_freertos.pas	(revision 46462)
+++ compiler/systems/t_freertos.pas	(working copy)
@@ -46,8 +46,6 @@
           function postprocessexecutable(const fn : string;isdll:boolean):boolean;
        end;
 
-       var
-         IDF_PATH: string;
 
 {*****************************************************************************
                                   TlinkerEmbedded
@@ -73,21 +71,7 @@
   platform_select='';
 {$endif}
 begin
-  with Info do
-   begin
-{$ifdef xtensa}
-     if target_info.system=system_xtensa_freertos then
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES '+
-         '-u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl -u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
-         '-L $IDF_PATH/components/esp_rom/esp32/ld '+
-         '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
-         '-L . -T esp32_out.ld -T esp32.project.ld '+
-         '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
-     else
-{$else}
-       ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
-{$endif xtensa}
-   end;
+  Info.ExeCmd[1]:='ld -g '+platform_select+' $OPT $DYNLINK $STATIC $GCSECTIONS $STRIP $MAP -L. -o $EXE -T $RES';
 end;
 
 
@@ -961,14 +945,11 @@
   hp: TCmdStrListItem;
   filepath: TCmdStr;
 begin
-  IDF_PATH:='';
-{$ifdef xtensa}
-  if (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      IDF_PATH := 'IDF_PATH'
-    else
-      IDF_PATH := 'IDF_PATH8266';
-{$endif xtensa}
+{$ifdef XTENSA}
+  { idfpath can be set by -Ff, else default to environment value of IDF_PATH }
+  if idfpath='' then
+    idfpath := trim(GetEnvironmentVariable('IDF_PATH'));
+{$endif XTENSA}
 
   { for future use }
   StaticStr:='';
@@ -979,194 +960,250 @@
   success:=true;
   Result:=false;
 
-  if target_info.system=system_xtensa_freertos then
+{$ifdef XTENSA}
+  { generate a sdkconfig.h if none is provided,
+    only a few fields are provided to far }
+  Assign(t,'sdkconfig.h');
+  {$push}{$I-}
+  Rewrite(t);
+  if ioresult<>0 then
+    exit;
+
+  if (current_settings.controllertype = ct_esp32) then
     begin
-      { generate a sdkconfig.h if none is provided,
-        only a few fields are provided to far }
-      if not(Sysutils.FileExists('sdkconfig.h')) then
-        begin
-          Assign(t,'sdkconfig.h');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
-          writeln(t,'#pragma once');
-          writeln(t,'#define CONFIG_APP_BUILD_USE_FLASH_SECTIONS 1');
-          writeln(t,'#define CONFIG_BT_RESERVE_DRAM 0x0');
-          writeln(t,'#define CONFIG_ESP32_ULP_COPROC_RESERVE_MEM 0');
-          writeln(t,'#define CONFIG_ESP32_TRACEMEM_RESERVE_DRAM 0x0');
+      writeln(t,'#pragma once');
+      writeln(t,'#define CONFIG_APP_BUILD_USE_FLASH_SECTIONS 1');
+      writeln(t,'#define CONFIG_BT_RESERVE_DRAM 0x0');
+      writeln(t,'#define CONFIG_ESP32_ULP_COPROC_RESERVE_MEM 0');
+      writeln(t,'#define CONFIG_ESP32_TRACEMEM_RESERVE_DRAM 0x0');
+    end
+  else
+    begin
+      { TODO: APP_OFFSET & APP_SIZE depends on partition table
+        Default for partition table: Single factory app, no OTA }
+      writeln(t,'#define APP_OFFSET 0x10000');
+      writeln(t,'#define APP_SIZE 0xf0000');
+      { Include build version of sdkconfig.h for custom configuration, if available }
+      S:=idfpath+'/libs/sdkconfig.h';
+      if SysUtils.FileExists(S) then
+        writeln(t,'#include "'+S+'"')
+      else
+        { Assume SOC_FULL_ICACHE option not selected (default) }
+        writeln(t,'#define CONFIG_SOC_IRAM_SIZE 0xC000');
+    end;
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+  Close(t);
+  if ioresult<>0 then
+    exit;
+  {$pop}
 
-      { generate an sdkconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('sdkconfig')) then
-        begin
-          Assign(t,'sdkconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+  { generate an sdkconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('sdkconfig')) then
+    begin
+      Assign(t,'sdkconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          writeln(t);
+      writeln(t);
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-      { generate an Kconfig if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig')) then
-        begin
-          Assign(t,'Kconfig');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+  { generate an Kconfig if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig')) then
+    begin
+      Assign(t,'Kconfig');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          writeln(t);
+      writeln(t);
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-      { generate an Kconfig.projbuild if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('Kconfig.projbuild')) then
-        begin
-          Assign(t,'Kconfig.projbuild');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+  { generate an Kconfig.projbuild if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('Kconfig.projbuild')) then
+    begin
+      Assign(t,'Kconfig.projbuild');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          writeln(t);
+      writeln(t);
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-      { generate an kconfigs.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs.in')) then
-        begin
-          Assign(t,'kconfigs.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
+  { generate an kconfigs.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs.in')) then
+    begin
+      Assign(t,'kconfigs.in');
+      {$push}{$I-}
+      Rewrite(t);
+      if ioresult<>0 then
+        exit;
 
-          writeln(t);
+      writeln(t);
 
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
+      Close(t);
+      if ioresult<>0 then
+        exit;
+      {$pop}
+    end;
 
-      { generate an kconfigs_projbuild.in if none is provided,
-        this is a dummy so far }
-      if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
-        begin
-          Assign(t,'kconfigs_projbuild.in');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
-
-          writeln(t);
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
-
-      { generate a config.env if none is provided,
-        COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
-        be needed to be filed properly }
-      if not(Sysutils.FileExists('config.env')) then
-        begin
-          Assign(t,'config.env');
-          {$push}{$I-}
-          Rewrite(t);
-          if ioresult<>0 then
-            exit;
-
-          writeln(t,'{');
-          writeln(t,'    "COMPONENT_KCONFIGS": "Kconfig",');
-          writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD": "Kconfig.projbuild",');
-          writeln(t,'    "IDF_CMAKE": "y",');
-          writeln(t,'    "IDF_TARGET": "esp32",');
-          writeln(t,'    "IDF_PATH": "'+GetEnvironmentVariable('IDF_PATH')+'",');
-          writeln(t,'    "COMPONENT_KCONFIGS_SOURCE_FILE": "kconfigs.in",');
-          writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD_SOURCE_FILE": "kconfigs_projbuild.in"');
-          writeln(t,'}');
-
-          Close(t);
-          if ioresult<>0 then
-            exit;
-          {$pop}
-        end;
-
-      { generate ldgen_libraries }
-      Assign(t,'ldgen_libraries');
+  { generate an kconfigs_projbuild.in if none is provided,
+    this is a dummy so far }
+  if not(Sysutils.FileExists('kconfigs_projbuild.in')) then
+    begin
+      Assign(t,'kconfigs_projbuild.in');
       {$push}{$I-}
       Rewrite(t);
       if ioresult<>0 then
         exit;
 
-      hp:=TCmdStrListItem(StaticLibFiles.First);
-      while assigned(hp) do
-        begin
-          FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
-          writeln(t,filepath);
-          hp:=TCmdStrListItem(hp.Next);
-        end;
+      writeln(t);
 
       Close(t);
       if ioresult<>0 then
         exit;
       {$pop}
+    end;
 
-      binstr:='xtensa-esp32-elf-gcc';
-      cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld';
+  { generate a config.env if none is provided,
+    COMPONENT_KCONFIGS and COMPONENT_KCONFIGS_PROJBUILD are dummy fields and might
+    be needed to be filed properly }
+  Assign(t,'config.env');
+  {$push}{$I-}
+  Rewrite(t);
+  if ioresult<>0 then
+    exit;
 
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      success:=DoExec(binstr,cmdstr,true,true);
+  writeln(t,'{');
+  if (current_settings.controllertype = ct_esp32) then
+    begin
+      writeln(t,'    "COMPONENT_KCONFIGS": "Kconfig",');
+      writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD": "Kconfig.projbuild",');
+      writeln(t,'    "IDF_CMAKE": "y",');
+      writeln(t,'    "IDF_TARGET": "esp32",');
+      writeln(t,'    "IDF_PATH": "'+idfpath+'",');
+      writeln(t,'    "COMPONENT_KCONFIGS_SOURCE_FILE": "kconfigs.in",');
+      writeln(t,'    "COMPONENT_KCONFIGS_PROJBUILD_SOURCE_FILE": "kconfigs_projbuild.in"');
+    end
+  else
+    begin
+      writeln(t,'    "IDF_PATH": "'+idfpath+'",');
+      writeln(t,'    "IDF_TARGET": "esp8266",');
+      writeln(t,'    "IDF_CMAKE": "n"');
+    end;
+  writeln(t,'}');
 
-      { generate linker maps for esp32 }
-      binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
-      cmdstr:='--config sdkconfig --fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
-        '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
-        '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
-        '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
-        '$IDF_PATH/components/esp_gdbstub/linker.lf '+
-        '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in --output ./esp32.project.ld --kconfig $IDF_PATH/Kconfig --env-file config.env '+
-        '--libraries-file ldgen_libraries --objdump xtensa-esp32-elf-objdump';
-      Replace(binstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      Replace(cmdstr,'$IDF_PATH',maybequoted(GetEnvironmentVariable('IDF_PATH')));
-      if success and not(cs_link_nolink in current_settings.globalswitches) then
-        success:=DoExec(binstr,cmdstr,true,false);
+  Close(t);
+  if ioresult<>0 then
+    exit;
+  {$pop}
+
+  { generate ldgen_libraries }
+  Assign(t,'ldgen_libraries');
+  {$push}{$I-}
+  Rewrite(t);
+  if ioresult<>0 then
+    exit;
+
+  hp:=TCmdStrListItem(StaticLibFiles.First);
+  while assigned(hp) do
+    begin
+      FindLibraryFile(hp.Str,target_info.staticClibprefix,target_info.staticClibext,filepath);
+      writeln(t,filepath);
+      hp:=TCmdStrListItem(hp.Next);
     end;
 
-  if IDF_PATH <> '' then
-    Replace(Info.ExeCmd[1],'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
+  Close(t);
+  if ioresult<>0 then
+    exit;
+  {$pop}
+
+  binstr:='gcc';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='-C -P -x c -E -o esp32_out.ld -I . $IDF_PATH/components/esp32/ld/esp32.ld'
+  else
+    cmdstr:='-C -P -x c -E -o esp8266_out.ld -I . $IDF_PATH/components/esp8266/ld/esp8266.ld';
+  Replace(cmdstr,'$IDF_PATH',idfpath);
+  success:=DoExec(FindUtil(utilsprefix+binstr),cmdstr,true,true);
+
+  { generate linker maps }
+  binstr:='$IDF_PATH/tools/ldgen/ldgen.py';
+  if (current_settings.controllertype = ct_esp32) then
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/xtensa/linker.lf $IDF_PATH/components/soc/linker.lf $IDF_PATH/components/esp_event/linker.lf '+
+            '$IDF_PATH/components/spi_flash/linker.lf $IDF_PATH/components/esp_wifi/linker.lf $IDF_PATH/components/lwip/linker.lf '+
+            '$IDF_PATH/components/heap/linker.lf $IDF_PATH/components/esp_ringbuf/linker.lf $IDF_PATH/components/espcoredump/linker.lf $IDF_PATH/components/esp32/linker.lf '+
+            '$IDF_PATH/components/esp32/ld/esp32_fragments.lf $IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/newlib/newlib.lf '+
+            '$IDF_PATH/components/esp_gdbstub/linker.lf '+
+            '--input $IDF_PATH/components/esp32/ld/esp32.project.ld.in '+
+            '--output ./esp32.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-esp32-elf-objdump'
+  else
+    cmdstr:='--config sdkconfig '+
+            '--fragments $IDF_PATH/components/esp8266/ld/esp8266_fragments.lf '+
+            '$IDF_PATH/components/esp8266/ld/esp8266_bss_fragments.lf $IDF_PATH/components/esp8266/linker.lf '+
+            '$IDF_PATH/components/freertos/linker.lf $IDF_PATH/components/log/linker.lf '+
+            '$IDF_PATH/components/lwip/linker.lf $IDF_PATH/components/spi_flash/linker.lf '+
+            '--env "COMPONENT_KCONFIGS_PROJBUILD=  $IDF_PATH/components/bootloader/Kconfig.projbuild '+
+            '$IDF_PATH/components/esptool_py/Kconfig.projbuild  $IDF_PATH/components/partition_table/Kconfig.projbuild"'+
+            '--env "COMPONENT_KCONFIGS=$IDF_PATH/components/app_update/Kconfig '+
+            '$IDF_PATH/components/esp8266/Kconfig  $IDF_PATH/components/freertos/Kconfig '+
+            '$IDF_PATH/components/log/Kconfig $IDF_PATH/components/lwip/Kconfig" '+
+            '--input $IDF_PATH/components/esp8266/ld/esp8266.project.ld.in '+
+            '--output ./esp8266.project.ld '+
+            '--kconfig $IDF_PATH/Kconfig '+
+            '--env-file config.env '+
+            '--libraries-file ldgen_libraries '+
+            '--objdump xtensa-lx106-elf-objdump';
+
+  Replace(binstr,'$IDF_PATH',idfpath);
+  Replace(cmdstr,'$IDF_PATH',idfpath);
+  if success and not(cs_link_nolink in current_settings.globalswitches) then
+    success:=DoExec(binstr,cmdstr,true,false);
+
+  if (current_settings.controllertype = ct_esp32) then
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start_cpu0 -u ld_include_panic_highint_hdl -u esp_app_desc -u vfs_include_syscalls_impl -u pthread_include_pthread_impl -u pthread_include_pthread_cond_impl -u pthread_include_pthread_local_storage_impl -u newlib_include_locks_impl '+
+       '-u newlib_include_heap_impl -u newlib_include_syscalls_impl -u newlib_include_pthread_impl -u app_main -u uxTopUsedPriority '+
+       '-L $IDF_PATH/components/esp_rom/esp32/ld '+
+       '-T esp32.rom.ld -T esp32.rom.libgcc.ld -T esp32.rom.newlib-data.ld -T esp32.rom.syscalls.ld -T esp32.rom.newlib-funcs.ld '+
+       '-L . -T esp32_out.ld -T esp32.project.ld '+
+       '-L $IDF_PATH/components/esp32/ld -T esp32.peripherals.ld'
+  else
+    Info.ExeCmd[1] := Info.ExeCmd[1]+' -u call_user_start -u g_esp_sys_info -u _printf_float -u _scanf_float '+
+      '-L $IDF_PATH/components/esp8266/ld -T esp8266.peripherals.ld -T esp8266.rom.ld '+ { SDK scripts }
+      '-L . -T esp8266_out.ld -T esp8266.project.ld'; { Project scripts }
+
+  Replace(Info.ExeCmd[1],'$IDF_PATH',idfpath);
+{$endif XTENSA}
+
   FixedExeFileName:=maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.elf')));
 
   GCSectionsStr:='--gc-sections';
-  //if not(cs_link_extern in current_settings.globalswitches) then
   if not(cs_link_nolink in current_settings.globalswitches) then
    Message1(exec_i_linking,current_module.exefilename);
 
@@ -1179,8 +1216,6 @@
 { Call linker }
   SplitBinCmd(Info.ExeCmd[1],binstr,cmdstr);
   Replace(cmdstr,'$OPT',Info.ExtraOptions);
-  if target_info.system=system_xtensa_freertos then
-    Replace(cmdstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
   if not(cs_link_on_target in current_settings.globalswitches) then
    begin
     Replace(cmdstr,'$EXE',FixedExeFileName);
@@ -1212,32 +1247,31 @@
   if success and not(cs_link_nolink in current_settings.globalswitches) then
     success:=PostProcessExecutable(FixedExeFileName,false);
 
-{$ifdef xtensa}
-  if success and (target_info.system=system_xtensa_freertos) then
-    if (current_settings.controllertype = ct_esp32) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--elf-sha256-offset 0xb0 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
-    else if (current_settings.controllertype = ct_esp8266) then
-      begin
-        binstr:='$'+IDF_PATH+'/components/esptool_py/esptool/esptool.py';
-        Replace(binstr,'$'+IDF_PATH,maybequoted(GetEnvironmentVariable(IDF_PATH)));
-        success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
-          '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
-          '--version=3 '+
-          '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
-          FixedExeFileName,
-          true,false);
-      end
+{$ifdef XTENSA}
+  if success then
+   begin
+      binstr:=idfpath+'/components/esptool_py/esptool/esptool.py';
+      if (current_settings.controllertype = ct_esp32) then
+        begin
+          success:=DoExec(binstr,'--chip esp32 elf2image --flash_mode dio --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--elf-sha256-offset 0xb0 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+      else if (current_settings.controllertype = ct_esp8266) then
+        begin
+          success:=DoExec(binstr,'--chip esp8266 elf2image --flash_mode dout --flash_freq 40m '+
+            '--flash_size '+tostr(embedded_controllers[current_settings.controllertype].flashsize div (1024*1024))+'MB '+
+            '--version=3 '+
+            '-o '+maybequoted(ScriptFixFileName(ChangeFileExt(current_module.exefilename,'.bin')))+' '+
+            FixedExeFileName,
+            true,false);
+        end
+   end
   else
-{$endif xtensa}
+{$endif XTENSA}
     if success then
       success:=DoExec(FindUtil(utilsprefix+'objcopy'),'-O binary '+
         FixedExeFileName+' '+
esp8266-freertos.patch (49,443 bytes)   

Florian

2020-08-20 23:30

administrator   ~0125046

Thanks, applied. Creating ESP8266 programs works now, I have also updated the wiki.

Christo Crause

2020-08-21 09:01

reporter   ~0125052

Thanks!

Issue History

Date Modified Username Field Change
2020-07-12 10:02 Christo Crause New Issue
2020-07-12 10:02 Christo Crause File Added: t_freertos.patch
2020-07-12 10:08 Christo Crause Note Added: 0123912
2020-07-12 10:34 Christo Crause Note Added: 0123913
2020-07-12 10:34 Christo Crause File Added: t_freertos2.patch
2020-08-18 21:47 Florian Note Added: 0124973
2020-08-19 07:37 Christo Crause Note Added: 0124977
2020-08-19 10:11 Florian Note Added: 0124981
2020-08-19 16:36 Christo Crause Note Added: 0124993
2020-08-19 21:17 Florian Note Added: 0124997
2020-08-20 17:32 Christo Crause Note Added: 0125032
2020-08-20 17:32 Christo Crause File Added: esp8266-freertos.patch
2020-08-20 23:30 Florian Assigned To => Florian
2020-08-20 23:30 Florian Status new => resolved
2020-08-20 23:30 Florian Resolution open => fixed
2020-08-20 23:30 Florian Fixed in Version => 3.3.1
2020-08-20 23:30 Florian Fixed in Revision => 46527
2020-08-20 23:30 Florian FPCTarget => -
2020-08-20 23:30 Florian Note Added: 0125046
2020-08-21 09:01 Christo Crause Status resolved => closed
2020-08-21 09:01 Christo Crause Note Added: 0125052